#include <cstdio>
#include <cstring>
#include <string>
#include <iostream>
#include <algorithm>
#include <cstdlib>
#include <iomanip>
#include <cmath>
#include <set>
#include <stack>
#include <vector>
#include <map>
#include <queue>
#include <utility>
#include <functional>
#include <numeric>

using namespace std;

typedef long long int lld;
typedef pair < int, int > pii;

const int MaxK = 10000 + 5;
const int MaxT = 10 + 5;
const lld INF = 1LL << 60LL;

typedef struct Polygon
{
    int T;
    lld MinX, MaxX, MinY, MaxY, X[MaxT], Y[MaxT];
    Polygon ( ) { }
};

int K;
lld X1, Y1, X2, Y2;
Polygon Polygons[MaxK];

int main ( void )
{
    cin.sync_with_stdio ( 0 );
    cout.sync_with_stdio ( 0 );

    cin >> X1 >> Y1 >> X2 >> Y2;
    cin >> K;
    for ( int i = 0; i < K; i++)
    {
        cin >> Polygons[i].T;
        Polygons[i].MinX = INF;
        Polygons[i].MinY = INF;
        Polygons[i].MaxX = -1LL * INF;
        Polygons[i].MaxY = -1LL * INF;
        for ( int j = 0; j < Polygons[i].T; j++ )
        {
            cin >> Polygons[i].X[j] >> Polygons[i].Y[j];
            Polygons[i].MinX = min ( Polygons[i].X[j], Polygons[i].MinX );
            Polygons[i].MaxX = max ( Polygons[i].X[j], Polygons[i].MaxX );
            Polygons[i].MinY = min ( Polygons[i].Y[j], Polygons[i].MinY );
            Polygons[i].MaxY = max ( Polygons[i].Y[j], Polygons[i].MaxY );
        }
    }

    bool OkX = X1 == X2, OkY = Y1 == Y2;
    int idx = 0, Sol = 0;
    while ( ! OkX || ! OkY )
    {
        Sol++;
        if ( ! OkX )
        {
            if ( X1 < X2 ) X1 = min ( X2, X1 + Polygons[idx].MaxX );
            else X1 = max ( X2, X1 + Polygons[idx].MinX );
        }
        if ( ! OkY )
        {
            if ( Y1 < Y2 ) Y1 = min ( Y2, Y1 + Polygons[idx].MaxY );
            else Y1 = max ( Y2, Y1 + Polygons[idx].MinY );
        }
        OkX = X1 == X2;
        OkY = Y1 == Y2;
        idx = ( idx + 1 ) % K;
    }
    cout << Sol << endl;
    return 0;
}
