#include <cstdio>
#include <cstring>
#include <string>
#include <iostream>
#include <algorithm>
#include <cstdlib>
#include <iomanip>
#include <cmath>
#include <set>
#include <stack>
#include <vector>
#include <map>
#include <queue>
#include <utility>
#include <functional>
#include <numeric>

using namespace std;

typedef long long int lld;
typedef pair < int, int > pii;

const int MaxN = 353535 + 5;
const lld BASE = 31337LL;
const lld MOD = 1e14 + 7LL;

int N, HashValue, A[MaxN], B[MaxN], Cnt[MaxN];
lld Pow[MaxN];
string S;
map < int, int > Hash;
map < lld, lld > SmartZ;

inline lld Solve ( void )
{
    Pow[0] = 1LL;
    for ( int i = 1; i < MaxN; i++ ) Pow[i] = ( Pow[i - 1] * BASE ) % MOD;

    lld CurrHash = 0LL;
    for ( int i = 0; i <= HashValue; i++ ) CurrHash = ( CurrHash + Pow[HashValue - i] * 67LL ) % MOD;
    SmartZ[CurrHash]++;

    lld Ret = 0LL;
    for ( int i = 0; i < N; i++ )
    {
        if ( Cnt[A[i]] )
        {
            CurrHash = ( CurrHash - Pow[HashValue - A[i]] * 139LL ) % MOD;
            if ( CurrHash < 0LL ) CurrHash += MOD;
            CurrHash = ( CurrHash + Pow[HashValue - A[i]] * 67LL ) % MOD;
        }
        else
        {
            CurrHash = ( CurrHash - Pow[HashValue - A[i]] * 67LL ) % MOD;
            if ( CurrHash < 0LL ) CurrHash += MOD;
            CurrHash = ( CurrHash + Pow[HashValue - A[i]] * 139LL ) % MOD;
        }

        Cnt[A[i]] = ( Cnt[A[i]] + 1 ) % 2;
        Ret += SmartZ[CurrHash];
        SmartZ[CurrHash]++;
    }
    return Ret;
}

int main ( void )
{
    scanf ( "%d", &N );
    for ( int i = 0; i < N; i++ )
    {
        scanf ( "%d", &A[i] );
        B[i] = A[i];
    }

    HashValue = -1;
    sort ( B, B + N );
    for ( int i = 0; i < N; i++ )
    {
        if ( i == 0 || B[i] != B[i - 1] ) HashValue++;
        Hash[B[i]] = HashValue;
    }
    for ( int i = 0; i < N; i++ ) A[i] = Hash[A[i]];
    cout << Solve ( ) << endl;

    return 0;
}
