/*
    Marko Bakovic, Delta3
    Srpska Informaticka Olimpijada
    Problem 5. Pljacka
*/

#include <cstdio>
#include <algorithm>
#include <iostream>

using namespace std;

typedef long long lld;

const int maxn = 500 + 5;

int n, m;

lld dp_left[ maxn ][ 2 ], dp_right[ maxn ][ 2 ], room[ maxn ][ maxn ], temp;

int main()
{
    scanf( "%d %d", &n, &m );
    for ( int i = 1; i <= n; i++ )
        for ( int j = 1; j <= m; j++ ) scanf( "%lld", &room[ i ][ j ] );

    for ( int i = 1; i <= n; i++ )
    {
        dp_left[ 1 ][ 0 ] = room[ i ][ 1 ];
        dp_left[ 1 ][ 1 ] = room[ i ][ 1 ] + room[ i - 1 ][ 1 ];
        for ( int j = 2; j <= m; j++ )
        {
            dp_left[ j ][ 0 ] = room[ i ][ j ] + max( dp_left[ j - 1 ][ 0 ], 0LL );
            dp_left[ j ][ 1 ] = room[ i ][ j ] + room[ i - 1 ][ j ] + max( dp_left[ j - 1 ][ 0 ], 0LL );
            dp_left[ j ][ 1 ] = max( dp_left[ j ][ 1 ], dp_left[ j - 1 ][ 1 ] + room[ i ][ j ] );
        }
        dp_right[ m ][ 0 ] = room[ i ][ m ];
        dp_right[ m ][ 1 ] = room[ i ][ m ] + room[ i - 1 ][ m ];
        for ( int j = m - 1; j >= 1; j-- )
        {
            dp_right[ j ][ 0 ] = room[ i ][ j ] + max( dp_right[ j + 1 ][ 0 ], 0LL );
            dp_right[ j ][ 1 ] = room[ i ][ j ] + room[ i - 1 ][ j ] + max( dp_right[ j + 1 ][ 0 ], 0LL );
            dp_right[ j ][ 1 ] = max( dp_right[ j ][ 1 ], dp_right[ j + 1 ][ 1 ] + room[ i ][ j ] );
        }
        for ( int j = 1; j <= m; j++ )
        {
            temp = room[ i ][ j ];
            temp = max( temp, room[ i ][ j ] + max( dp_left[ j - 1 ][ 0 ], 0LL ) + max( dp_right[ j + 1 ][ 0 ], 0LL ) );
            temp = max( temp, room[ i ][ j ] + max( dp_left[ j - 1 ][ 1 ], 0LL ) + max( dp_right[ j + 1 ][ 0 ], 0LL ) );
            temp = max( temp, room[ i ][ j ] + max( dp_left[ j - 1 ][ 0 ], 0LL ) + max( dp_right[ j + 1 ][ 1 ], 0LL ) );
            temp = max( temp, room[ i ][ j ] + room[ i - 1 ][ j ] + max( dp_left[ j - 1 ][ 0 ], 0LL ) + max( dp_right[ j + 1 ][ 0 ], 0LL ) );
            room[ i ][ j ] = temp;
        }
    }

    lld sol = lld( -1e9 );
    for ( int i = 1; i <= n; i++ )
        for ( int j = 1; j <= m; j++ ) sol = max( sol, room[ i ][ j ] );

    printf( "%lld\n", sol );

    return 0;
}
