#include <cstdio>
#include <cstring>
#include <algorithm>
#define MOD 1000000007
#define BROJ 69
using namespace std;

struct tablica{
    short int Duzine[BROJ+2];
    inline friend tablica operator +(tablica a,tablica b){
        tablica tmp;
        for (int i=1; i<=BROJ; i++){
            tmp.Duzine[i] = a.Duzine[i] + b.Duzine[i];
        }
        return tmp;
    }
    inline friend tablica operator -(tablica a,tablica b){
        tablica tmp;
        for (int i=1; i<=BROJ; i++){
            tmp.Duzine[i] = a.Duzine[i] - b.Duzine[i];
        }
        return tmp;
    }
    void shaltaj(int br){
        for (int i=BROJ; i>=1; i--) Duzine[i] = Duzine[i-1];
        Duzine[1] = br;
    }
    void antishaltaj(){
        //dal ce mi i ovo treba
        for (int i=1; i<BROJ; i++) Duzine[i] = Duzine[i+1];
        Duzine[BROJ] = 0;
    }
    void ispisi(){
        int i;
        for (i=1; i<=BROJ; i++) printf("%d%c",Duzine[i],i==BROJ?'\n':' ');
    }
};

tablica T[16000],Tgore[16000],Tdole[16000],prazna;
int P1[16000],P2[16000],PA[16000],C[16000],O[32000],D[16000],N,Pauk;

void ucitajisredi(){
    int i;
    scanf("%d%d",&N,&Pauk);
    for (i=1; i<N; i++){
        scanf("%d%d",P1+i,P2+i);
        C[P1[i]]++;
        C[P2[i]]++;
    }
    PA[1] = 1;
    for (i=2; i<=N+1; i++) PA[i] = PA[i-1] + C[i-1];
    memset(C,0,sizeof(C));
    for (i=1; i<N; i++){
        O[PA[P1[i]]+C[P1[i]]] = P2[i];
        O[PA[P2[i]]+C[P2[i]]] = P1[i];
        C[P1[i]]++;
        C[P2[i]]++;
    }
}

//dfs0 racuna tablice za tipa grane koje idu na dole i neverovatno su KUUL

void dfs0(int x,int odakle){
    int i,br=0;
    for (i=PA[x]; i<PA[x+1]; i++) if (O[i]!=odakle){
        D[O[i]] = D[x] + 1;
        dfs0(O[i],x);
        T[x] = T[x] + T[O[i]];
        br++;
    }
    T[x].shaltaj(br);
}

//prebacuje kao za cvorove u bas za grane al te grane na dole da idu

void zgumbetaj_dole(){
    int i;
    for (i=2; i<=N; i++){
        Tdole[i] = T[i];
        Tdole[i].shaltaj(1);
    }
}

//aj kako sad na gore majku mu

void dfs1(int x,int odakle){
    int i,br=0;
    T[x] = Tgore[x];
    for (i=PA[x]; i<PA[x+1]; i++) if (O[i]!=odakle){
        T[x] = T[x] + Tdole[O[i]];
    }
    for (i=PA[x]; i<PA[x+1]; i++) if (O[i]!=odakle){
        Tgore[O[i]] = T[x] - Tdole[O[i]];
        Tgore[O[i]].shaltaj(1);
    }
    for (i=PA[x]; i<PA[x+1]; i++) if (O[i]!=odakle){
        dfs1(O[i],x);
    }
}

//lei

void debug_0(){
    printf("tablice za na dole:\n");
    int i;
    for (i=1; i<=N; i++){
        printf("%d : ",i);
        Tdole[i].ispisi();
    }
    printf("tablice za na gore:\n");
    for (i=1; i<=N; i++){
        printf("%d : ",i);
        Tgore[i].ispisi();
    }
    printf("STOSIC GAZDA\n");
}

//sada malo matematike

int Dinamicko[16000][BROJ+2];
int T2[16000];
//D[i,j] = proizvod svaka j od 1..i

int proizvod_svaka_k(int *A,int N,int K){
    //assuming 1..N and K<N
    if (K>N) return 0; //evo ti uslov jebao te uslov
    int i,j;
    Dinamicko[0][0] = 1; // jes da mi ne treba al aj
    for (i=1; i<=K; i++) Dinamicko[i][i] = ((long long)Dinamicko[i-1][i-1] * A[i] ) % MOD;
    Dinamicko[1][1] = A[1];
    for (i=2; i<=N; i++) Dinamicko[i][1] = (A[i] + Dinamicko[i-1][1]) % MOD; //nece treba al aj
    for (j=2; j<=K; j++){
        for (i=j+1; i<=N; i++){
            Dinamicko[i][j] = ((long long)A[i] * Dinamicko[i-1][j-1] + Dinamicko[i-1][j]) % MOD;
            //printf("%d %d %d\n",i,j,Dinamicko[i][j]);
        }
    }
    return Dinamicko[N][K];
}

void debug_1(){
    printf("%d\n",proizvod_svaka_k(T2,5,3));
}

inline int broji_bre(int x,int duzina_kraka,int broj_krakova){
    int i,j;
    j=0;
    for (i=PA[x]; i<PA[x+1]; i++){
        j++;
        if (D[O[i]] > D[x]){
            T2[j] = Tdole[O[i]].Duzine[duzina_kraka];
        } else {
            T2[j] = Tgore[x].Duzine[duzina_kraka];
        }
    }
    return proizvod_svaka_k(T2,j,broj_krakova);
}

void resi(){
    int sol=0,i,j,k;
    //j je inace broj krakova
    for (j=3; j<=Pauk-1; j++){
        if ((Pauk-1)%j == 0){
            k = (Pauk-1)/j;
            for (i=1; i<=N; i++){
                sol += broji_bre(i,k,j);
                sol %= MOD;
            }
        }
    }
    printf("%d\n",sol);
}

int main(){
    //freopen("pauk.in.txt","r",stdin);
    ucitajisredi();
    dfs0(1,1);
    zgumbetaj_dole();
    dfs1(1,1);
    resi();
    //debug_0();
    //debug_1();
    return 0;
}

