#include <iostream>
#include <cstdio>
#include <algorithm>

using namespace std;

struct put
{
    int id, asf, putarina;
    int pp;
    int x, y;
    int cena;
};

struct node
{
    put data;
    node *next;
    node();
};

node::node()
{
    next=NULL;
}

struct razd
{
    int id, d;
};

bool operator<(razd a, razd b)
{
    if(a.d<b.d) return true;
    return false;
}

int n, e;
const int N=20005;
const int E=200005;
const int INF=1000000000;
razd dist[N];
int id2[N];
int used1[N];
int used2[N];
int vp[N];
int min1[N];
node *a[N];
put p[E];

void delete_node(node *tmp)
{
    if(tmp!=NULL)
        delete_node(tmp->next);
    delete tmp;
}

void delete_graph()
{
    int i;
    for(i=0; i<=n; i++)
        delete_node(a[i]);
}

struct heap
{
    razd a[N];
    int n;
    void push(razd);
    void update(int, razd);
    void pop();
    razd top();
    bool empty();
};

bool heap::empty()
{
    if(n>0) return false;
    return true;
}

razd heap::top()
{
    if(!empty())
        return a[1];
}

void heap::push(razd x)
{
    n++;
    a[n]=x;
    int tmp=n;
    razd tmpr;
    while(tmp>1)
    {
        if(a[tmp].d<a[tmp/2].d)
        {
            id2[a[tmp/2].id]=tmp;
            tmpr=a[tmp];
            a[tmp]=a[tmp/2];
            a[tmp/2]=tmpr;
            tmp/=2;
        }
        else break;
    }
    id2[a[tmp].id]=tmp;
}

void heap::pop()
{
    a[1]=a[n];
    a[n].d=INF;
    id2[a[1].id]=1;
    n--;
    int tmp=1;
    if(tmp>n/2) return;
    razd tmpr;
    while(a[tmp].d>a[2*tmp].d || a[tmp].d>a[2*tmp+1].d)
    {
        if(a[2*tmp].d<a[2*tmp+1].d)
        {
            //swap(a[tmp], a[2*tmp]);
            id2[a[2*tmp].id]=tmp;
            id2[a[tmp].id]=2*tmp;
            tmpr=a[tmp];
            a[tmp]=a[2*tmp];
            a[2*tmp]=tmpr;
            tmp=2*tmp;
        }
        else
        {
            //swap(a[tmp], a[2*tmp+1]);
            id2[a[2*tmp+1].id]=tmp;
            id2[a[tmp].id]=2*tmp+1;
            tmpr=a[tmp];
            a[tmp]=a[2*tmp+1];
            a[2*tmp+1]=tmpr;
            tmp=2*tmp+1;
        }
        if(tmp>n/2) break;
    }
}

void heap::update(int x, razd y)
{
    //Na mesto x broj y!
    if(a[x].d==y.d) return;
    int tmp=x;
    razd tmpr;
    if(a[x].d>y.d)
    {
        a[x]=y;
        while(tmp>1)
        {
            if(a[tmp]<a[tmp/2])
            {
                id2[a[tmp/2].id]=tmp;
                tmpr=a[tmp];
                a[tmp]=a[tmp/2];
                a[tmp/2]=tmpr;
                tmp/=2;
            }
            else break;
        }
    }
    else
    {
        a[x]=y;
        if(tmp>n/2) return;
        while(a[tmp].d>a[2*tmp].d || a[tmp].d>a[2*tmp+1].d)
        {
            if(a[tmp*2]<a[tmp*2+1])
            {
                id2[a[2*tmp].id]=tmp;
                id2[a[tmp].id]=2*tmp;
                tmpr=a[tmp];
                a[tmp]=a[2*tmp];
                a[2*tmp]=tmpr;
                tmp=2*tmp;
            }
            else
            {
                id2[a[2*tmp+1].id]=tmp;
                id2[a[tmp].id]=2*tmp+1;
                tmpr=a[tmp];
                a[tmp]=a[2*tmp+1];
                a[2*tmp+1]=tmpr;
                tmp=2*tmp+1;
            }
        }
    }
}

void set()
{
    int i;
    for(i=0; i<=n; i++)
    {
        a[i]=new node;
        dist[i].id=i;
    }
}

void add_edge(int x, int y, int c, int d, int i)
{
    x--;
    y--;
    node *tmp;
    i++;
    tmp=new node;
    tmp->data.id=i;
    tmp->data.asf=c;
    tmp->data.putarina=d;
    tmp->data.pp=y; // Put na koji pokazuje
    tmp->next=a[x]->next;
    tmp->data.x=x;
    tmp->data.y=y;
    a[x]->next=tmp;
    tmp=new node;
    tmp->data.id=i;
    tmp->data.asf=c;
    tmp->data.putarina=d;
    tmp->data.pp=x; // Put na koji pokazuje
    tmp->next=a[y]->next;
    tmp->data.x=x;
    tmp->data.y=y;
    a[y]->next=tmp;
}

heap h1, h2;

void d1()
{
    int i;
    razd tmpr;
    tmpr.d=0;
    tmpr.id=0;
    int curr;
    h1.push(tmpr);
    for(i=1; i<n; i++)
    //UPDATE!!!!!
    {
        dist[i].d=INF;
        tmpr.d=INF;
        tmpr.id=i;
        h1.push(tmpr);
    }
    node *tmp;
    for(i=0; i<n; i++)
    {
        curr=h1.top().id;
        h1.pop();

        tmp=a[curr]->next;
        while(tmp!=NULL)
        {
            if(used1[tmp->data.pp])
            {
                tmp=tmp->next;
                continue;
            }
            //dist[tmp->data.pp]=min(dist[tmp->data.pp], dist[curr]+tmp->data.putarina);
            if(dist[tmp->data.pp].d>dist[curr].d+tmp->data.putarina)
            {
                dist[tmp->data.pp].d=dist[curr].d+tmp->data.putarina;
                min1[tmp->data.pp]=tmp->data.putarina;
                h1.update(id2[tmp->data.pp], dist[tmp->data.pp]);
            }
            tmp=tmp->next;
        }
        used1[curr]=1;
    }
}

void setVP()
{
    int i;
    node *tmp;
    for(i=1; i<n; i++)
    {
        tmp=a[i]->next;
        vp[i]=dist[i].d+min1[i];
        while(tmp!=NULL)
            vp[i]=min(vp[i], dist[tmp->data.pp].d+tmp->data.putarina);
    }
}

void nadji_cenu()
{
    int i;
    for(i=0; i<e; i++)
    {
        p[i].cena=min(dist[p[i].x].d+vp[p[i].y], dist[p[i].y].d+ vp[p[i].x]);
        p[i].cena+=p[i].asf;
    }
}

void solve2()
{
    node *tmp;
    int min1tmp;
    int i;
    int index;
    int indexx, indexy;
    int indexp;
    for(i=0; i<n-1; i++)
    {
        tmp=a[dist[i].id]->next;
        min1tmp=INF;
        while(tmp!=NULL)
        {
            while(used2[tmp->data.pp])
            {
                tmp=tmp->next;
                if(tmp==NULL) break;
            }
            if(tmp==NULL) break;
            if(tmp->data.cena<min1tmp)
            {
                min1tmp=tmp->data.cena;
                index=tmp->data.id;
                indexx=tmp->data.x;
                indexy=tmp->data.y;
                indexp=tmp->data.pp;
            }
            tmp=tmp->next;
        }
        used2[dist[i].id]=1;
        //printf("ID:%i\n", dist[i].id);
        //r+=min1tmp;
        //printf("INdex: %i Indexx: %i Indexy: %i\n", index, indexx, indexy);
        printf("%i ", index);
    }
}

int main()
{
    int i;
    int x, y, c, d;
    scanf("%i %i", &n, &e);
    set();
    setVP();
    for(i=0; i<e; i++)
    {
        scanf("%i %i %i %i", &x, &y, &c, &d);
        add_edge(x, y, c, d, i);
        p[i].x=x;
        p[i].y=y;
    }
    d1();
    nadji_cenu();
    sort(dist, dist+n);
    reverse(dist, dist+n);
    printf("%i\n", n-1);
    solve2();
    delete_graph();
    //cout << r << endl;
    return 0;
}

/*void dijkstra2()
{
    int i;
    int curr;
    razd tmpr;
    tmpr.d=0;
    tmpr.id=0;
    g2[0]=0;
    h2.push(tmpr);
    for(i=1; i<n; i++)
    {
        dist2[i]=INF;
        tmpr.d=INF;
        tmpr.id=i;
        h2.push(tmpr);
    }
    node *tmp;
    for(i=0; i<n; i++)
    {
        curr=h2.top();
        h2.pop();
        tmp=a[curr]->next;
        while(tmp!=NULL)
        {
            if(used2[tmp->data.pp])
            {
                tmp=tmp->next;
                continue;
            }
            if(min2[tmp.pp])
            {
                if(min2[curr])
                {
                    if(dist2[curr]-g2[curr]+2*tmp->data.putarina<dist2[tmp->data.pp])
                    {
                        dist2[tmp->data.pp]=dist2[curr]-g2[curr]+2*tmp->data.putarina;
                        g2[tmp->data.pp]=tmp->data.putarina;
                    }dist2[curr]-g2[curr]+2*tmp->data.putarina
                }
                else
                {
                    if(dist2[curr]-g2
                }
                //if(dist2[curr]-g2[curr]+2*tmp->data.putarina
                //dist2[tmp->data.pp]=min(dist2[tmp->data.pp], dist2[curr]-g2[curr]+2*tmp->data.putarina);
            }
            dist2[i]=min(dist2[i],
        }
    }
}
*/

